﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace MvcForExport.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            GrapeCity.ActiveReports.PageReport report = new GrapeCity.ActiveReports.PageReport(new System.IO.FileInfo(Server.MapPath("~/Reports/rptInvoice1.rdlx")));


            ViewData.Model = report;

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }

        public ActionResult ExportExcel()
        {
            GrapeCity.ActiveReports.PageReport _reportDef = new GrapeCity.ActiveReports.PageReport(new FileInfo(Server.MapPath("/Reports/rptInvoice1.rdlx")));
            GrapeCity.ActiveReports.Document.PageDocument _reportRuntime = new GrapeCity.ActiveReports.Document.PageDocument(_reportDef);

            // Create an output directory
            System.IO.MemoryStream ms = new System.IO.MemoryStream();

            // Provide settings for your rendering output.
            GrapeCity.ActiveReports.Export.Excel.Page.ExcelRenderingExtensionSettings
            excelSetting = new GrapeCity.ActiveReports.Export.Excel.Page.ExcelRenderingExtensionSettings();
            excelSetting.FileFormat = GrapeCity.ActiveReports.Export.Excel.Page.FileFormat.Xlsx;
            excelSetting.MultiSheet = true;
            GrapeCity.ActiveReports.Extensibility.Rendering.ISettings setting = excelSetting;

            //Set the rendering extension and render the report.
            GrapeCity.ActiveReports.Export.Excel.Page.ExcelRenderingExtension
            excelRenderingExtension = new
            GrapeCity.ActiveReports.Export.Excel.Page.ExcelRenderingExtension();
            GrapeCity.ActiveReports.Rendering.IO.MemoryStreamProvider outputProvider = new GrapeCity.ActiveReports.Rendering.IO.MemoryStreamProvider();
            _reportRuntime.Render(excelRenderingExtension, outputProvider, excelSetting.GetSettings());

            outputProvider.GetPrimaryStream().OpenStream().CopyTo(ms);
            return File(ms.ToArray(), "application/vnd.ms-excel", Url.Encode("export.xlsx"));
        }

         public ActionResult ExportPDF()
         {
             GrapeCity.ActiveReports.PageReport _reportDef = new GrapeCity.ActiveReports.PageReport(new FileInfo(Server.MapPath("/Reports/rptInvoice1.rdlx")));
             GrapeCity.ActiveReports.Document.PageDocument _reportRuntime = new GrapeCity.ActiveReports.Document.PageDocument(_reportDef);

             // Create an output directory
             System.IO.MemoryStream ms = new System.IO.MemoryStream();

             // Provide settings for your rendering output.
             GrapeCity.ActiveReports.Export.Pdf.Page.Settings pdfSetting = new
             GrapeCity.ActiveReports.Export.Pdf.Page.Settings();
             GrapeCity.ActiveReports.Extensibility.Rendering.ISettings setting = pdfSetting;
             
             //Set the rendering extension and render the report.
             GrapeCity.ActiveReports.Export.Pdf.Page.PdfRenderingExtension pdfRenderingExtension =
             new GrapeCity.ActiveReports.Export.Pdf.Page.PdfRenderingExtension();
             GrapeCity.ActiveReports.Rendering.IO.MemoryStreamProvider outputProvider = new GrapeCity.ActiveReports.Rendering.IO.MemoryStreamProvider();
             _reportRuntime.Render(pdfRenderingExtension, outputProvider, pdfSetting);

             outputProvider.GetPrimaryStream().OpenStream().CopyTo(ms);
             return File(ms.ToArray(), "application/pdf", Url.Encode("export.pdf"));
         }
    }
}
